﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Threading;

namespace ProducerConsumerQ
{
    public class Consumer
    {
        private static Thread consumerThread;
        private static EventWaitHandle wh = new EventWaitHandle(false, EventResetMode.AutoReset, "WaitingGate");
        public static Thread StartConsumption(Queue<string> queue)
        {
            if (consumerThread == null)
            {
                consumerThread = new Thread((q) =>
                {
                    Random r = new Random();
                    while (true)
                    {
                        string mesg = null;
                        lock (q)
                            if ((q as Queue<string>).Count > 0)
                            {
                                mesg = (q as Queue<string>).Dequeue();
                                if (mesg == null) return;
                            }
                        if (mesg != null)
                        {
                            Console.WriteLine("C: I'v consumed: " + mesg);
                            Thread.Sleep(r.Next(0, 40));
                        }
                        else
                        {
                            //sometimes it happens twice
                            Console.WriteLine("C: So I'm waiting..."); 
                            wh.WaitOne(); 
                        }
                    }
                });
                consumerThread.Start(queue);
            }
            else
            {
                Console.WriteLine("There is already one thread");
            }
            return consumerThread;
        }
    }
}
