﻿using System;
using System.Threading;

namespace ReadyGo
{
    class Program
    {

        static EventWaitHandle ready = new AutoResetEvent(false);
        static EventWaitHandle go = new AutoResetEvent(false);
        static volatile string job;

        static Random r;
        static void Main(string[] args)
        {
            r = new Random();
            new Thread(Consumer).Start();
            for (int i = 1; i <= 15; i++) //order job 5 times
            {
                ready.WaitOne(); // Waiting for consumer ready
                job = "a".PadRight(i, 'a'); // prepare job
                Thread.Sleep(r.Next(500));
                go.Set(); // signal job are ready to read
            }
            ready.WaitOne(); job = null; go.Set(); // it is signal to end
            Console.ReadKey();
        }

        static void Consumer()
        {
            while (true)
            {
                ready.Set(); // Inform producer we are ready
                go.WaitOne(); // and waiting for a job
                if (job == null) return; // when we get null we ends
                Console.WriteLine(job);
            //    Thread.Sleep(r.Next(500));
            }
        }
    }
}
